/*
  This program gives a chance for all people who want to change their main OS with a better OS like linux, but
  has problems with the difficult use of it.
  More comments on the program.

  First released on 19/June/2000, creator Mario Medina, medisoft@alohabbs.org.mx
*/
#include <errno.h>
extern int errno;
#include <stdio.h>
#include <signal.h>
#include <string.h>
#include <sys/stat.h>
#include <sys/mount.h>
#include <unistd.h>
#include <sys/types.h>
#include <fcntl.h>

#include <linux/cdrom.h>

#include <netinet/in.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <netdb.h>

#include <unistd.h>

#include "kamount.h"

int debug=0;
int wmanager=0; // 0=kde 1=gnome

char *icon = ""
"# KDE Config File\n"
"[KDE Desktop Entry]\n"
"Name=%s\n"
"MountPoint=%s\n"
"Icon=%s\n"
"UnmountIcon=%s\n"
"Dev=%s\n"
"ReadOnly=0\n"
"FSType=Default\n"
"Type=FSDevice\n";


struct DEVICES **dev=NULL;


char *tmpname(struct DEVICES *);
char *tmpuname(struct DEVICES *);
int sendcddb(struct DEVICES *);


void refreshdesktop(void)
{
  switch(wmanager) {
  	case 0: // kde
		  system("kfmclient refreshDesktop");
		  break;
  	case 1: //gnome
  		system("gmc-client --rescan-desktop");
  		break;
  	default: // nothing
  }
}
void *sigterm()
{
  int i;
	for(i=0;dev[i]!=NULL;i++) {
	  if((dev[i]->status&MEDIA)==MEDIA) {
	    unlink(tmpname(dev[i]));
	    unlink(tmpuname(dev[i]));
	  }
	}
	refreshdesktop();
	if(debug) printf("Fin del programa por algun signal\n");
	exit(0);
}

char *fixedname(char *src)
{
  char *buf=(char *)malloc(strlen(src)+1);
  int j;

  strcpy(buf,src);
  // Removes spaces and some other trash from the end of the string
	while(buf[strlen(buf)-1]<=32&&strlen(buf)>0) buf[strlen(buf)-1]=0;
	// changes all the / with _ so i can create a file with that name
	for(j=0;j<strlen(buf);j++)
		switch(buf[j]) {
			case '/': buf[j]='_'; break;
			default:
		}
  return buf;
}

char *tmpname(struct DEVICES *dev)
{
	char tmpfile[2048];
	char *ret;
	char desktop[1024];
	switch(wmanager) {
		case 0:
			strcpy(desktop,"Desktop");
			break;
		case 1:
			strcpy(desktop,".gnome-desktop");
			break;
		default:
			return "";
	}
	if(dev->pname!=NULL)
 		sprintf(tmpfile,"%s/%s/%s.kdelnk",getenv("HOME"),desktop,fixedname(dev->pname));
 else
	 	sprintf(tmpfile,"%s/%s/%s.kdelnk",getenv("HOME"),desktop,fixedname(dev->name));
 	ret=(char *)malloc(strlen(tmpfile)+1);
 	bzero(ret,sizeof(ret));
 	strcpy(ret,tmpfile);
 	return ret;
}

char *tmpuname(struct DEVICES *dev)
{
	char tmpfile[2048];
	char *ret;
	char desktop[1024];
	switch(wmanager) {
		case 0:
			strcpy(desktop,"Desktop/Trash");
			break;
		case 1:
			strcpy(desktop,".gnome-desktop/Trash");
			break;
		default:
			return "";
	}
	
	if(dev->pname!=NULL)
 		sprintf(tmpfile,"%s/%s/%s.kdelnk",getenv("HOME"),desktop,fixedname(dev->pname));
 	else
	 	sprintf(tmpfile,"%s/%s/%s.kdelnk",getenv("HOME"),desktop,fixedname(dev->name));
 	ret=(char *)malloc(strlen(tmpfile)+1);
 	bzero(ret,sizeof(ret));
 	strcpy(ret,tmpfile);
 	return ret;
}

int puticon(struct DEVICES *dev)
{
	FILE *fp;
	char *tmpfile;
	char cmd[2048];
	char *device;
	
 	tmpfile=tmpname(dev);
	
	if((fp=fopen(tmpfile,"wt"))==NULL) return -1;
	if(strlen(dev->pdevice)&&dev->dev_type>0) device=dev->pdevice; else device=dev->device;
	if(dev->picon!=NULL)
    fprintf(fp,icon,device,dev->mountpoint,dev->picon,dev->uicon,device);
  else
    fprintf(fp,icon,device,dev->mountpoint,dev->icon,dev->uicon,device);
  fclose(fp);
 	
	if(debug) printf("%s -> %s\n",dev->mountpoint,tmpfile);
  refreshdesktop();
  return 0;	
}

int polldevice(struct DEVICES *dev)
{
	struct stat st;
	FILE *fp;
	int p;
	struct cdrom_subchnl sc;
	if(stat(dev->device,&st)==-1) return 0;

	if(cd_status(dev))	
	  return MEDIA;
	else
  	return 0;
}


int
cddb_sum(int n)
{
	char	buf[12],
		*p;
	int	ret = 0;
	long unsigned int ntemp = 0;
	ntemp = (long unsigned int) n;

	/* For backward compatibility this algorithm must not change */
	sprintf(buf, "%lu", ntemp);
	for (p = buf; *p != '\0'; p++)
		ret += (*p - '0');

	return (ret);
}


/*
 * Get the start time and mode (data or audio) of a track.
 */
int
gen_get_trackinfo(d, track, data, startframe)
	int d;
	int		track, *data, *startframe;
{
	struct cdrom_tocentry	entry;

	entry.cdte_track = track;
	entry.cdte_format = CDROM_MSF;

	if (ioctl(d, CDROMREADTOCENTRY, &entry))
		return (-1);
	
	*startframe =	entry.cdte_addr.msf.minute * 60 * 75 +
			entry.cdte_addr.msf.second * 75 +
			entry.cdte_addr.msf.frame;
	*data = entry.cdte_ctrl & CDROM_DATA_TRACK ? 1 : 0;
	
	return (0);
}

/*
 * Get the number of frames on the CD.
 */
int
get_cdlen(d, frames)
	int d;
	int		*frames;
{
	int		tmp;

	return (gen_get_trackinfo(d, CDROM_LEADOUT, &tmp, frames));
}


int cd_status(struct DEVICES *dev)
{
	int p;
	unsigned long disc_id;
	int t,n,tempframe;
	int i;
	struct cdrom_subchnl sc;
	
	struct cdrom_tocentry te;
	struct cdrom_tochdr	hdr;


	
	p=open(dev->device,O_RDONLY|O_NONBLOCK);
	if(p<0) {
		if(errno!=6)
		  if(debug) perror("open");
	  return 0;
	}
	bzero((void *)&sc,sizeof(sc));
	sc.cdsc_format=CDROM_MSF;
	if (ioctl(p, CDROMSUBCHNL, &sc)<0) {
	  close(p);
    // The device don't looks like a CDROM, maybe a harddisk, jaz, zip, floppy or another
    if(errno==EINVAL) {
      dev->dev_type=10;
      dev->tocreaded=0;
      return MEDIA;
    }
    return (0);
	}
	
	switch(sc.cdsc_audiostatus) {
  	case CDROM_AUDIO_PLAY:
  	case CDROM_AUDIO_PAUSED:
	  case CDROM_AUDIO_NO_STATUS:
  	case CDROM_AUDIO_INVALID:
	  case CDROM_AUDIO_COMPLETED:
	  	// it is a CDROM, so i try to get the TOC, i will use it with CDDB if music CD
	    dev->dev_type=sc.cdsc_ctrl;
	    if(dev->tocreaded==0) {
  	    dev->serial=sc.cdsc_absaddr.lba;
      	if (ioctl(p, CDROMREADTOCHDR, &hdr)) {
      	  dev->dev_type=0;
    	    dev->tocreaded=0;
    	    close(p);
      	  if(errno==123) return 0; // No medium found error, i don't know the default name of the error, but the errno
      	  perror("gettrack");
      	  return 0;
    	  } else {
    	    // Free cddbtoc structure
      	  if(dev->cddbtoc!=NULL&&dev->ntracks>0) {
      	    for(i=0;i<dev->ntracks+1;i++) {
      	      if(dev->cddbtoc[i]->pname!=NULL) free(dev->cddbtoc[i]->pname), dev->cddbtoc[i]->pname=NULL;
    	        free(dev->cddbtoc[i]), dev->cddbtoc[i]=NULL;
    	      }
    	      free(dev->cddbtoc);
      	    dev->cddbtoc=NULL;
      	  }
      	  // initialize disc_id and other numbers
    	    disc_id=n=t=0;
    	    // set the number of tracks of this CD
      	  dev->ntracks=hdr.cdth_trk1;
      	  // fill the new cddb structure
      	  dev->cddbtoc=(void *)realloc(dev->cddbtoc,sizeof(void *)*(dev->ntracks+2));
    	    for(i=0;i<dev->ntracks;i++) {
          	te.cdte_track = i+1;
	          te.cdte_format = CDROM_MSF;
      	    if(ioctl(p,CDROMREADTOCENTRY,&te)) perror("gettoc");
      	    dev->cddbtoc[i]=(struct TOC *)malloc(sizeof(struct TOC));
      	    dev->cddbtoc[i]->pname=NULL;
    	      dev->cddbtoc[i]->min=te.cdte_addr.msf.minute;
    	      dev->cddbtoc[i]->sec=te.cdte_addr.msf.second;
    	      dev->cddbtoc[i]->frame=te.cdte_addr.msf.frame;
      			dev->cddbtoc[i]->absframe =
	  	    	    dev->cddbtoc[i]->min * 60 * 75
		  	      + dev->cddbtoc[i]->sec * 75
    	  		  + dev->cddbtoc[i]->frame;
     	    }
          dev->cddbtoc[dev->ntracks]=(struct TOC *)malloc(sizeof(struct TOC));
     	    dev->cddbtoc[dev->ntracks]->pname=NULL;
      	
    	    if(get_cdlen(p,&tempframe)<0) perror("CD cddb length read");
      	  dev->cddbtoc[dev->ntracks]->min   = tempframe/(60*75);
        	dev->cddbtoc[dev->ntracks]->sec   = (tempframe - dev->cddbtoc[dev->ntracks]->min * 60 * 75)/75;

        	dev->cddbtoc[dev->ntracks]->frame =
                           tempframe - dev->cddbtoc[dev->ntracks]->min * 60 * 75
	                      - dev->cddbtoc[dev->ntracks]->sec *75;

        	dev->cddbtoc[dev->ntracks]->absframe = tempframe;
        	dev->nsecs=((dev->cddbtoc[dev->ntracks]->min*60)+dev->cddbtoc[dev->ntracks]->sec);
      	  // Ok, i have all the information i need, then i go to obtain the disc_id for
    	    // cddb search (if the CD doesn't has the name inside, i try to get it from cddb)
    	    for(i=0;i<hdr.cdth_trk1;i++) {
    	      n+=cddb_sum((dev->cddbtoc[i]->min*60)+dev->cddbtoc[i]->sec);
       	  }
	        t = ((dev->cddbtoc[dev->ntracks]->min * 60)
      	     + dev->cddbtoc[dev->ntracks]->sec) -
	           ((dev->cddbtoc[0]->min * 60) + dev->cddbtoc[0]->sec);
   	      disc_id=(unsigned long)((n % 0xff) << 24 | t << 8 | hdr.cdth_trk1);
    	    dev->serial=disc_id;
    	    dev->tocreaded=1;
    	  }
        printf("TOC readed, disc type %d\n",dev->dev_type);
      } else {
        // Here i check if the disc was ejected ... i couldn't read the TOC and get error 123 = no medium found then
        // i return a nice error :) else, if an error different 123 i return an ugly error
      	if (ioctl(p, CDROMREADTOCHDR, &hdr)) {
      	  dev->dev_type=0;
    	    dev->tocreaded=0;
    	    close(p);
      	  if(errno==123) return 0; // No medium found error, i don't know the default name of the error, but the errno
      	  perror("gettrack");
      	  return 0;
      	}
      }
	    break;
	  default:
	    close(p);
	    return 0;
	}
	close(p);
	return MEDIA;
}

/*
  Here i check if the media has been ejected, no matter if it has been put on the trash, unmounted and ejected
  or forced ejected, i will detect it (i hope!)
*/
int pollumounted(struct DEVICES *dev)
{
	struct stat st;
	// Check if the media is inserted...
	if(!cd_status(dev)) {
	  // Nop, some weird program umounts and ejected it without my permission
	  unlink(tmpname(dev));
	  unlink(tmpuname(dev));
	  dev->mountcount=0;
	  dev->status=0;
	  dev->tocreaded=0;
	  dev->fstype=-1;
	  strcpy(dev->pdevice,"");
    refreshdesktop();
	  if(debug) printf("Extracted forcing, without notifying KAMount???\n");
	  return 0;
	}
	
	// Check if my beautiful icon still exists....
	if(stat(tmpname(dev),&st)==-1) {
	  // it doesn't, does it exists on trash??? if yes, then notify that
  	if(stat(tmpuname(dev),&st)==-1) {
  	  // ups! who deleted my icons!!!! i want it on the desktop, so y put it again
  	  puticon(dev);
  	  return dev->status;
  	} else {
  	  // Ok, ok, ok, i will eject the media... snif! you must not be sad with that disk
  	  return EJECTED;
  	}
  }
}
/*
  I read all the configuration, it consist on a list of drives that i will check, careful with cdwriters!!!
  i don't know very well if it works on all of them, but you can trash a disk if don't have care.
*/
struct DEVICES **readConfig(void)
{
	FILE *fp;
	struct DEVICES **dev=NULL;
	char buf[1024];
	int i;
	// Open the configuration file... i know, i know... it should be named kamount.conf not automount.conf, but hey! it is
	// my program, isn't it? hehehehe...
	if((fp=fopen("/etc/automount.conf","rt"))==NULL) return NULL;
	while(fgets(buf,sizeof(buf),fp)) {
		if(dev==NULL) {
			dev=(void *)malloc(sizeof(void *)*2);
			dev[0]=dev[1]=NULL;
		}
		for(i=0;dev[i]!=NULL;i++);
		dev=(void *)realloc(dev,sizeof(void *)*(i+2));
		dev[i+1]=NULL;
		dev[i]=(struct DEVICES *)malloc(sizeof(struct DEVICES));
		
    // Allocate all the memory for a single device and initializate all the variables
		dev[i]->device=(char *)malloc(strlen(buf));
		dev[i]->pdevice=(char *)malloc(strlen(buf));
		dev[i]->mountpoint=(char *)malloc(strlen(buf));
		dev[i]->dev_id=(char *)malloc(strlen(buf));
		dev[i]->name=(char *)malloc(strlen(buf));
		dev[i]->icon=(char *)malloc(strlen(buf));
		dev[i]->uicon=(char *)malloc(strlen(buf));
		dev[i]->mountcount=0;
		dev[i]->tocreaded=0;
		dev[i]->fstype=-1;
		dev[i]->pname=NULL;
		dev[i]->picon=NULL;
		dev[i]->cddbtoc=NULL;
		dev[i]->category=NULL;
		dev[i]->ntracks=0;
		
		bzero(dev[i]->device,strlen(buf));
		bzero(dev[i]->pdevice,strlen(buf));
		bzero(dev[i]->mountpoint,strlen(buf));
		bzero(dev[i]->dev_id,strlen(buf));
		bzero(dev[i]->name,strlen(buf));
		bzero(dev[i]->icon,strlen(buf));
		bzero(dev[i]->uicon,strlen(buf));
		sscanf(buf,"%s%s%s%s%s%s",dev[i]->device,dev[i]->mountpoint,dev[i]->name,dev[i]->icon,dev[i]->uicon,dev[i]->dev_id);

    // i has a problem here... segmentation fault, but i don't know why, if you know why please tell me :)
/*		
		dev[i]->device=(char *)realloc(dev[i]->device,strlen(dev[i]->device)+1);
		dev[i]->mountpoint=(char *)realloc(dev[i]->mountpoint,strlen(dev[i]->mountpoint)+1);
		dev[i]->dev_id=(char *)realloc(dev[i]->dev_id,strlen(dev[i]->dev_id)+1);
		dev[i]->name=(char *)realloc(dev[i]->name,strlen(dev[i]->name)+1);
		dev[i]->icon=(char *)realloc(dev[i]->icon,strlen(dev[i]->icon)+1);
		dev[i]->uicon=(char *)realloc(dev[i]->icon,strlen(dev[i]->icon)+1);*/
		
		// I check if some of the devices i handle is premounted, if yes i fill the device data on my devices structure
		// for not to try to remount it, only put the icon on the desktop
		checkpremounted(dev[i]);
		
	}
	fclose(fp);
	return dev;
}

/*
  Guess it!
*/
char *strtolower(char *src)
{
  char *tmp=(char *)malloc(strlen(src)+1);
  int i;
  for(i=0;i<strlen(src);i++) tmp[i]=tolower(src[i]);
  tmp[i]=0;
  return tmp;
}
/*
  I check for autorun.inf or linuxrun.dat, the files that give me information about the icon of a disk with the
  iso9660 standard.... maybe on some time in the future i can guess if have wine, and then run the windoze .exe
  files, but at this time only gives me the name of the icon, when it is an icon, not an exe file with icons.
  If you know how to extract the icons of an exe file, or from a macintosh disk, please tell me.
*/
int checkautorun(struct DEVICES *dev)
{
  FILE *fp;
  char autorun[1024];
  char icono[2048];
  char cmd[2048];
  int i;

  if(dev->picon!=NULL) {
    free(dev->picon);
    dev->picon=NULL;
  }
  // For windoze drives
  sprintf(autorun,"%s/autorun.inf",dev->mountpoint);
  if((fp=fopen(autorun,"rt"))!=NULL) {
    while(fgets(icono,sizeof(icono),fp)) {
      for(i=0;i<strlen(icono);i++) {
        if(icono[i]=='\\') icono[i]='/';
        if(icono[i]<32) icono[i]=0;
      }
      // I need to convert the image (.ico) to .xpm, i use a tool called convert, it comes with all distros i know
      // like redhat, debian, suse and slackware, it is part of imagemagik
      if(!strncmp(strtolower(icono),"icon=",5)) {
	      struct stat st;
        strcpy(icono,(char *)&icono[5]);
       	sprintf(cmd,"%s/%s",dev->mountpoint,icono);
      	
      	if(stat(cmd,(struct stat *)&st)<0)
      	  strcpy(icono,strtolower(icono));

       	sprintf(cmd,"%s/%s",dev->mountpoint,icono);
      	if(stat(cmd,(struct statbuf *)&st)>=0) {
          if(strrchr(icono,'/')!=NULL)
            sprintf(cmd,"convert -colors 256 %s/%s /tmp%s.xpm 2>&1 > /dev/null",dev->mountpoint,icono,strrchr(icono,'/'));
          else
            sprintf(cmd,"convert -colors 256 %s/%s /tmp/%s.xpm 2>&1 > /dev/null",dev->mountpoint,icono,icono);
          printf("%s\n",cmd);
          i=system(cmd);
          if(i!=0)
            i=system(strtolower(cmd))&0xff00;
         	
          if(strrchr(icono,'/')!=NULL)
            sprintf(cmd,"/tmp%s.xpm",strrchr(icono,'/'));
          else
            sprintf(cmd,"/tmp/%s.xpm",icono);
        	if(stat(cmd,(struct stat *)&st)<0) i=1;
       } else i=1;
        if(i==0) {
          dev->picon=(char *)realloc(dev->picon,strlen(cmd)+1);
          if(strrchr(icono,'/')!=NULL)
            sprintf(dev->picon,"/tmp%s.xpm",strrchr(icono,'/'));
          else
            sprintf(dev->picon,"/tmp/%s.xpm",icono);
        }
      }
    }
    fclose(fp);
  } else { // For kamount format of linuxrun.dat
  sprintf(autorun,"%s/linuxrun.dat",dev->mountpoint);
  if((fp=fopen(autorun,"rt"))!=NULL) {
    while(fgets(icono,sizeof(icono),fp)) {
      for(i=0;i<strlen(icono);i++) {
        if(icono[i]=='\\') icono[i]='/';
        if(icono[i]<32) icono[i]=0;
      }
      // I don't know why, but i will convert an xpm to xpm hehehehehe! a simple copy&paste without much work :P
      // no, being serious, i think some xpm files may not be compatible with the kde routines, so i transform it
      // to xpm again to ensure (i don't know how to tell "asegurar", my english is not perfect :P ) that it works
      // Last news!!! i look that the icons must not have more than 256 colors, so it is perfect that convert exists!
      if(!strncmp(strtolower(icono),"icon=",5)) {
        strcpy(icono,(char *)&icono[5]);
        if(strrchr(icono,'/')!=NULL)
          sprintf(cmd,"convert -colors 256 %s/%s /tmp%s.xpm 2>&1 > /dev/null",dev->mountpoint,icono,strrchr(icono,'/'));
        else
          sprintf(cmd,"convert -colors 256 %s/%s /tmp/%s.xpm 2>&1 > /dev/null",dev->mountpoint,icono,icono);
        printf("%s\n",cmd);
        i=system(cmd)&0xff00;
        if(i!=0)
          i=system(strtolower(cmd))&0xff00;
        if(i==0) {
          dev->picon=(char *)realloc(dev->picon,strlen(cmd)+1);
          if(strrchr(icono,'/')!=NULL)
            sprintf(dev->picon,"/tmp%s.xpm",strrchr(icono,'/'));
          else
            sprintf(dev->picon,"/tmp/%s.xpm",icono);
        }
      }
    }
    fclose(fp);
  }
  }
}

char *memstr(char *src, char *fnd, unsigned long size, unsigned long tsize, unsigned long *offset)
{
	register unsigned long i;
//	printf("Searching for %lu bytes for %lu %s\n",size,tsize,fnd);
	for(i=0;i<size;i++) {
		if(!memcmp((src+i),fnd,tsize)) {
//		  printf("On offset %08lx\n",i);
			*offset+=i;
		  return (src+i);
		}
	}
//	printf("I get byte %lu and not found\n",i);
	return NULL;
}

char *devicename(struct DEVICES *dev, int fstype)
{
	FILE *fp;
	char buf[1024];
	char j;
	char *device;
	//fstype=2;
	switch(fstype) {
		case 0: // iso9660
			if((fp=fopen(dev->device,"rb"))!=NULL) {
				fseek(fp,0x8028,0);
				fread(buf,1,0x80,fp);
				fclose(fp);
				dev->pname=(char *)malloc(strlen(buf)+1);
				strcpy(dev->pname,buf);
				if(strlen(dev->pname)==0)
				  dev->pname=NULL;
				else
  				if(debug) printf("Name (%d) %s\n",strlen(dev->pname),dev->pname);
			}
			break;
		case 1: // vfat
			if(strlen(dev->pdevice)) device=dev->pdevice; else device=dev->device;
			if((fp=fopen(device,"rb"))!=NULL) {
			  unsigned int id=0;
				fread((char *)&id,1,2,fp);
		  	printf("disco %04x\n",id);
				switch(id) {
				  case 0x3ceb: // Floppy drive
				  case 0x3eeb: // Jaz
				    fseek(fp,0x2b,0);
				    break;
				  case 0x58eb: // Hard drive
				    fseek(fp,0x47,0);
				    break;
				  default:
				    id=-1;
				}
			  if(id!=-1) {
			    bzero(buf,sizeof(buf));
  				fread(buf,1,10,fp);
  				fclose(fp);
	  			dev->pname=(char *)malloc(strlen(buf)+1);
		  		strcpy(dev->pname,buf);
			  	if(strlen(dev->pname)==0)
				    dev->pname=NULL;
  				else
    				if(debug) printf("Name (%d) %s\n",strlen(dev->pname),dev->pname);
    		}
			}
			break;
		case 2: // hfs, please! someone who tells me how to obtain the disk name without using this program! it makes the software
		        // slower
			  // Update! yeah, i get it! on the kernel headers was the structure definition for the partition of a hfs disk
			  // only a little tryies and i get it working for all disks i could probe
				dev->pname=gethfsname(dev);
			
/*			sprintf(buf,"echo \"quit\" | hfs %s 2>&1 | grep -i volume\\ name | "
			            "sed -e \"s/Volume name is \\\"//\" | cut -d '\"' -f 1",dev->device);
			if((fp=popen(buf,"r"))!=NULL) {
				fgets(buf,sizeof(buf),fp);
				while(buf[strlen(buf)-1]<32&&strlen(buf)>0) buf[strlen(buf)-1]=0;
				pclose(fp);
				dev->pname=(char *)malloc(strlen(buf)+1);
				strcpy(dev->pname,buf);
				if(strlen(dev->pname)==0)
				  dev->pname=NULL;
				else
  				if(debug) printf("Name (%d) %s\n",strlen(dev->pname),dev->pname);
			}*/
				if(dev->pname!=NULL)
  				if(debug) printf("Name (%d) %s\n",strlen(dev->pname),dev->pname);
			break;
		default:
		  // This is generally for music discs, i try to get the name from my local database
  	  if(loadcddb(dev)) {
  	    // i cannot get it from the local database, so i make a request to a server
        if(getcddb(dev)==0) {
          // i get it from some server, i will store it for another time
          savecddb(dev);
        } else {
          // i can't get the label, i will show the serial number, if it exists, if not i use the default name
          // it is the worst of all the names it can take, but....
    		  if(dev->serial!=0) {
	    	    sprintf(buf,"%lu",dev->serial);
		    		dev->pname=(char *)malloc(strlen(buf)+1);
			    	strcpy(dev->pname,buf);
				    if(strlen(dev->pname)==0)
				      dev->pname=NULL;
    				else
      				if(debug) printf("Name (%d) %s\n",strlen(dev->pname),dev->pname);
  	    	}
  	    }
  	 }
	}
	// guess...
	checkautorun(dev);
}
/*
  add the entry of the mounted device to /etc/mtab
*/
int addmtab(struct DEVICES *dev, char *fstype)
{
  FILE *fp;
  char dt[1024];
  char mt[1024];
  char *tmp=NULL;
  int tmpl=0;
  char *device;
  if(strlen(dev->pdevice)&&dev->dev_type>0) device=dev->pdevice; else device=dev->device;
  sprintf(dt,"%s %s %s %s 0 0\n",device,dev->mountpoint,fstype,(dev->dev_type==1||dev->dev_type==4||dev->dev_type==6)?"ro":"rw");
  if((fp=fopen("/etc/mtab","rt"))!=NULL) {
    while(fgets(mt,sizeof(mt),fp)) {
      if(strncmp(mt,device,strlen(device))) {
        tmp=(char *)realloc(tmp,tmpl+strlen(mt)+1);
        strcpy((tmp+tmpl),mt);
        tmpl+=strlen(mt);
      }
    }
    tmp=(char *)realloc(tmp,tmpl+strlen(dt)+1);
    strcpy((tmp+tmpl),dt);
    fclose(fp);
    unlink("/etc/mtab.tmp");
    if(rename("/etc/mtab","/etc/mtab.tmp")>=0) {
	    if((fp=fopen("/etc/mtab","wb"))!=NULL) {
  	    if(fwrite(tmp,1,strlen(tmp),fp)!=strlen(tmp)) {
  	    	fclose(fp);
  	    	rename("/etc/mtab.tmp","/etc/mtab");
  	    } else
	    	  fclose(fp);
	    } else rename("/etc/mtab.tmp","/etc/mtab");
  	} else perror("rename");
  }
  if(tmp!=NULL) free(tmp);
  tmp=NULL;
  return 0;
}
/*
  remove the entry of an unmounted device from /etc/mtab
*/
int delmtab(struct DEVICES *dev)
{
  FILE *fp;
  char mt[1024];
  char *tmp=NULL;
  int tmpl=0;
  char *device;
  if(strlen(dev->pdevice)&&dev->dev_type>0) device=dev->pdevice; else device=dev->device;
  if((fp=fopen("/etc/mtab","rt"))!=NULL) {
    while(fgets(mt,sizeof(mt),fp)) {
      if(strncmp(mt,device,strlen(device))) {
        tmp=(char *)realloc(tmp,tmpl+strlen(mt)+1);
        strcpy((tmp+tmpl),mt);
        tmpl+=strlen(mt);
      }
    }
    fclose(fp);
    unlink("/etc/mtab.tmp");
    if(rename("/etc/mtab","/etc/mtab.tmp")>=0) {
	    if((fp=fopen("/etc/mtab","wb"))!=NULL) {
  	    if(fwrite(tmp,1,strlen(tmp),fp)!=strlen(tmp)) {
  	    	fclose(fp);
  	    	rename("/etc/mtab.tmp","/etc/mtab");
  	    } else
	    	  fclose(fp);
	    } else rename("/etc/mtab.tmp","/etc/mtab");
		} else perror("rename");
  }
  if(tmp!=NULL) free(tmp);
  tmp=NULL;
  return 0;
}

// All the filesystems i know that can be put on a jaz/zip/cdrom in order of use...
// the first and most common is iso9660 for cdroms, i know a lot of people that has cdroms, but not much of them has
// another removible disk; then i know the people who has jaz/zip drives, they use windoze, so i put vfat first
// and then the mac people, who works with hfs filesystem. msdos filesystem, nfs and the others are not common
// but i put it for compatibility
char *fstype[]={"iso9660","vfat","hfs","msdos","nfs","ext2","minix",NULL };

/*
  Mount the device... if it can be mounted, if not only put the icon.
  If the drive is a "partitionable" drive, like jaz/zip drives, then check from 1 to 7, i don't know if anyone has
  a drive with more than 7 partitions, if yes maybe a detect routine will solve the problem... in a future hehe
*/
int mountdevice(struct DEVICES *dev)
{
	int i,r=-1,partition;

	if(debug) printf("Mounting %s ",dev->device);
	fflush(stdout);
	// Frees the not standard (aka: gived by the drive/cddb) name of the media
 	if(dev->pname!=NULL) {
 	  free(dev->pname);
 	  dev->pname=NULL;
 	}

  // Is it a harddrive, jaz, zip or other writable and partitionable media, or data cdrom????
  if(dev->dev_type>0) { // yes! it is
    // is the media premounted????
 		if(dev->fstype==-1) { // Nop, i will try to mount it
	 		for(i=0,r=-1;fstype[i]!=NULL&&r!=0;i++) {
	 			// Guessing, does it has partitions, like zip/jaz/harddrive or not, like a floppy disk?
	 			if(!strncmp(dev->device,"/dev/fd",7)||dev->dev_type==1||dev->dev_type==4||dev->dev_type==6) { // It is a floppy, it doesn't has partitions
	 				if(dev->dev_type==1||dev->dev_type==4||dev->dev_type==6) {// it is readonly media
		 		 		r=mount(dev->device,dev->mountpoint,fstype[i],0xc0ed0000|MS_RDONLY,(void *)0);
  		 		} else {
		 		  	r=mount(dev->device,dev->mountpoint,fstype[i],0xc0ed0000/*|MS_RDONLY*/,(void *)0);
		 		  }
  			 	if(r!=0) {
  			 	  // It is already mounted
  	 				if(errno==EBUSY) {
			 				if(dev->dev_type==1||dev->dev_type==4||dev->dev_type==6) {// it is readonly media
			  				r=mount(dev->device,dev->mountpoint,fstype[i],0xc0ed0000|MS_RDONLY|MS_REMOUNT,(void *)0);
			  			} else {
			  				r=mount(dev->device,dev->mountpoint,fstype[i],0xc0ed0000/*|MS_RDONLY*/|MS_REMOUNT,(void *)0);
			  			}
			  			if(r!=0) perror("remount");
	  		 		}
  	 			}
  	 		} else { // it has partitions! check all of them
  	 			for(partition=0;partition<7&&r!=0;partition++) {
  	 				sprintf(dev->pdevice,"%s%d",dev->device,partition);
		 		  	r=mount(dev->pdevice,dev->mountpoint,fstype[i],0xc0ed0000/*|MS_RDONLY*/,(void *)0);
	  			 	if(r!=0) {
  				 	  // It is already mounted
  		 				if(errno==EBUSY) {
		  					r=mount(dev->pdevice,dev->mountpoint,fstype[i],0xc0ed0000/*|MS_RDONLY*/|MS_REMOUNT,(void *)0);
			  				if(r!=0) perror("remount");
	  		 			}
  		 			}
  		 		}
  	 		}
  	 		// I add the entry on /etc/mtab file
	 		  if(r==0) addmtab(dev,fstype[i]);
	 		}
	 		dev->fstype=i-1;
	 	} else {
	 		addmtab(dev,fstype[dev->fstype]);
	 		r=0;
	 	}
  }
  // Ok, i have mounted the media, if it can be mounted, so i proceed to add the icon on the desktop
	if(r==0) {
		if(debug) printf("%s on device %s\n",fstype[dev->fstype],dev->pdevice);
			
		// Removes all the previous icons of this device, i don't want a lot of trash icons on the desktop
		unlink(tmpname(dev));
		unlink(tmpuname(dev));
			
		// Obtains the name of the disk
		devicename(dev,dev->fstype);
			
		// Put the icon, and refresh desktop to show it
		puticon(dev);
		dev->mountcount=-1;
		// Set the flag of a mounted filesystem
		dev->status|=MOUNTED;
		return 0;
	} else {
		// Removes all the previous icons of this device, i don't want a lot of trash icons on the desktop
		unlink(tmpname(dev));
		unlink(tmpuname(dev));
		
		// Obtains the name of the disc
		devicename(dev,-1);
			
		// Put the icon, and refresh desktop to show it
		puticon(dev);
		if(debug) printf("unknown/music\n");
		dev->mountcount=-1;
	}
	return -1;
}
/*
  Guess!! i only tell you that this function tryies to unmount a device, if it is succesful, then ejects it
  if not puts the icon again on the desktop
*/
int umountdevice(struct DEVICES *dev)
{
	int r;
	char tmp[1024];
  char *device;
  if(strlen(dev->pdevice)&&dev->dev_type>0) device=dev->pdevice; else device=dev->device;
	if(debug) printf("Unmounting %s ",device);
	fflush(stdout);
	if(umount(device)&&(dev->status&MOUNTED)) {
		if(debug) perror("umount");
		rename(tmpuname(dev),tmpname(dev));
		if(debug) printf("i can't\n");
		if(dev->status&EJECTED) dev->status-=EJECTED;
	} else {
		unlink(tmpuname(dev));
		sprintf(tmp,"eject %s 2>&1 > /dev/null",dev->device);
		r=system(tmp);
		if((r&0x00ff)) {
  		rename(tmpuname(dev),tmpname(dev));
	  	if(debug) printf("no pude\n");
		} else {
  		if(debug&&dev->status&MOUNTED) printf("unmounted ");
	  	if(debug&&!(r&&0x00ff)) printf("ejected");
		  if(debug) printf("\n");
  		if(dev->status&MOUNTED) dev->status-=MOUNTED;
	  	if(!(r&0x00ff)&&dev->status&MEDIA) dev->status-=MEDIA;
		  if(!(r&0x00ff)&&dev->status&EJECTED) dev->status-=EJECTED;
  		delmtab(dev);
  		dev->tocreaded=0;
  		dev->fstype=-1;
    }
	}
  refreshdesktop();
	return dev->status;
}




/*
  This function makes the directories to store cddb and other information
*/
int createdirs(void)
{
  char tmpfile[1024];
  sprintf(tmpfile,"%s/.kamount",getenv("HOME"));
  mkdir(tmpfile,0754);
  sprintf(tmpfile,"%s/.kamount/cddb",getenv("HOME"));
  mkdir(tmpfile,0754);
  return 0;
}

/*
  This function gets the INET address of a host, using DNS
*/
unsigned long dir_INET(hostName)
char *hostName;
{
   struct hostent* hostStruct;
   struct in_addr* hostNode;
   hostStruct=gethostbyname(hostName);
   if (hostStruct==NULL)
        {
        perror("dir_INET");
        return 0;
        }
   hostNode=(struct in_addr*) hostStruct->h_addr;
   return (hostNode->s_addr);
}

/*
  This function saves the name of a disk obtained from cddb database
*/
int savecddb(struct DEVICES *dev)
{
  char tmpfile[1024];
  FILE *fp;
  sprintf(tmpfile,"%s/.kamount/cddb/%08lx.cddb",getenv("HOME"),dev->serial);
  if((fp=fopen(tmpfile,"wt"))!=NULL) {
    if(dev->pname!=NULL) fprintf(fp,"NAME=%s\n",dev->pname);
    fclose(fp);
    return 0;
  }
  return -1;
}

/*
  This function loads the name of a disk obtained from cddb database
*/
int loadcddb(struct DEVICES *dev)
{
  char tmpfile[1024];
  char buf[1024];
  FILE *fp;
  sprintf(tmpfile,"%s/.kamount/cddb/%08lx.cddb",getenv("HOME"),dev->serial);
  if((fp=fopen(tmpfile,"rt"))!=NULL) {
    while(fgets(buf,sizeof(buf),fp)) {
      buf[strlen(buf)-1]=0;
      if(!strncmp(buf,"NAME=",5)) {
        dev->pname=(char *)realloc(dev->pname,strlen(buf));
        strcpy(dev->pname,(char *)&buf[5]);
        break;
      }
    }
    fclose(fp);
    return 0;
  }
  return -1;
}

/*
  on some partes of the cddb routine i need to get line by line, so i wait until i get the carriage return and line feed sequence
  before return the data.
*/
int myread(int sock, char *buf, int size)
{
  int i,r;
  bzero(buf,size);
  for(i=0;i<size;i++) {
    if(strlen(buf)>0) if(!strcmp((char *)&buf[strlen(buf)-2],"\r\n")) return i;
    r=read(sock,(char *)&buf[i],1);
  }
  return i;
}

struct CDDBSRVS {
  char *addr;
  int port;
};
/*
  This function connects to a server with cddb protocol and gets the name of a CD
*/
int getcddb(struct DEVICES *dev)
{
  struct sockaddr_in sockname;
  // I readed about the problem with cddb.com servers, so i better use freedb as a first try
  struct CDDBSRVS srvs[] = { { "freedb.freedb.org", 888 }, { "sc.ca.us.cddb.com", 8880 }, { "sj.ca.us.cddb.com", 8880 }, { "sj2.ca.us.cddb.com", 8880 } };
  int sock;
  char bin[4096];
  char bout[4096];
  char buf[4096];
  int r,i;
  int server, masterstat=0;

  for(server=0;server<(sizeof(srvs)/sizeof(struct CDDBSRVS));server++) {

    printf("\nTrying server %s at port %u\n",srvs[server].addr,srvs[server].port);
    if((sock=socket(AF_INET,SOCK_STREAM,0))==-1) { perror("socket:getcddb"); return -1; }

    sockname.sin_family=AF_INET;
    sockname.sin_addr.s_addr=dir_INET(srvs[server].addr); // address of the cddb host
    sockname.sin_port=htons(srvs[server].port); // port of the cddb protocol, sometimes 888, sometimes 8880

    // Connect to server...
    if(connect(sock,(struct sockaddr *)&sockname,sizeof(sockname))==-1) {
      perror("connect:getcddb");
      // if can connect, try another server
      goto endcddb;
    }

    // Read hello string
    r=read(sock,bin,sizeof(bin));
    if(r<0) {
      perror("read:getcddb");
      goto endcddb;
    }
    bin[r]=0;
    printf("<< %s",bin);
    if(strncmp(bin,"200",3)&&strncmp(bin,"201",3)) {
      printf("unknown answer\n");
      goto endcddb;
    }

    // Send my hello string
    sprintf(bout,"cddb hello %s %s KAMount %s \n",getenv("USER"),getenv("HOSTNAME"),VERSION);
    r=write(sock,bout,strlen(bout));
    if(r<0) {
      perror("read:getcddb");
      goto endcddb;
    }
    printf(">> %s",bout);
    // Read the answer of my salute
    r=read(sock,bin,sizeof(bin));
    if(r<0) {
      perror("read:getcddb");
      goto endcddb;
    }
    bin[r]=0;
    printf("<< %s",bin);
    if(strncmp(bin,"200",3)) {
      printf("unknown answer\n");
      goto endcddb;
    }
    // Now i go to grain, i send the petition for the information of the cd
    sprintf(bout,"cddb query %08lx %u ",dev->serial,dev->ntracks);
    for(i=0;i<dev->ntracks;i++)
      sprintf((char *)&bout[strlen(bout)],"%lu ",dev->cddbtoc[i]->absframe);
    sprintf((char *)&bout[strlen(bout)],"%u\n",dev->nsecs);
    r=write(sock,bout,strlen(bout));
    printf(">> %s",bout);
    if(r<0) {
      perror("read:getcddb");
      goto endcddb;
    }
    // Ok! i now read the answer
    bzero(bin,sizeof(bin));
    r=read(sock,bin,sizeof(bin));
    if(r<0) {
      perror("read:getcddb");
      goto endcddb;
    }
    bin[r]=0;
    printf("<< %s",bin);
    if(strncmp(bin,"200",3)) {
      printf("unknown disc\n");
      // I need to know what i check with other server, if i get that the freedb don't know about the title
      // i will submit it to it if i get the answer from another
      if(server==0) masterstat=1;
      goto endcddb;
    }
    // I get the title and the category of the CD!
    printf("Devolvio %s",bin);

    // Obtains the category and the name of the disk
    sscanf(bin,"%s%s",bout,buf);
    dev->category=(char *)realloc(dev->category,strlen(buf)+1);
    strcpy(dev->category,buf);
  	strcpy(bin,strchr(strchr(strchr(bin,' ')+1,' ')+1,' ')+1);
    // Removes spaces and some other trash from the end of the string
  	while(bin[strlen(bin)-1]<=32&&strlen(bin)>0) bin[strlen(bin)-1]=0;
    dev->pname=(char *)realloc(dev->pname,strlen(bin)+1);
    strcpy(dev->pname,bin);


    // Gets the name of all the tracks
    sprintf(bout,"CDDB READ %s %08lx\n",dev->category,dev->serial);
    r=write(sock,bout,strlen(bout));
    printf(">> %s",bout);
    if(r<0) {
      perror("read:getcddb");
      goto endcddb;
    }
    // I get the answer of my query
    bzero(bin,sizeof(bin));
    r=myread(sock,bin,sizeof(bin));
    if(r<0) {
      perror("read:getcddb");
      goto endcddb;
    }
    bin[r]=0;
    printf("<< %s",bin);
    if(strncmp(bin,"210",3)) {
      printf("unknown answer\n");
      goto endcddb;
    }
    // Yeah! the server has all the information about this title, so i proceed to make my own list in memory
    i=0;
    do {
      bzero(bin,sizeof(bin));
      r=myread(sock,bin,sizeof(bin));
      if(r<0) {
        perror("read:getcddb");
        goto endcddb;
      }
      bin[r]=0;
      printf("<< %s",bin);
      if(!strncmp(bin,"TTITLE",6)) {
        // I get a track title, i add it to my data
    	  while((bin[strlen(bin)-1]=='\n'||bin[strlen(bin)-1]=='\r')&&strlen(bin)>0) bin[strlen(bin)-1]=0;
        dev->cddbtoc[i]->pname=(char *)malloc(strlen(bin)-5);
        strcpy(dev->cddbtoc[i]->pname,strchr(bin,'=')+1);
        i++;
      }
    // when i get only a period on a single line, then it's over
    } while(strcmp(bin,".\r\n"));


    // All finished, to be kind I quit with the right command, not only closing the socket
    sprintf(bout,"QUIT\n");
    r=write(sock,bout,strlen(bout));
    printf(">> %s",bout);
    if(r<0) {
      perror("write:getcddb:quit");
      goto okcddb;
    }
    // I really don't want to know the answer... but we must be polite with the others ;>
    bzero(bin,sizeof(bin));
    r=read(sock,bin,sizeof(bin));
    if(r<0) {
      perror("read:getcddb:quit");
      goto okcddb;
    }
    bin[r]=0;
    printf("<< %s",bin);

  okcddb:;
    // Close the socket connection with my host
    close(sock);

    // I have all i need, so if i'm using the first server i return, but if i don't, then i submit the data to the first
    // and really important server, we want to have the freecddb database as complete as possible
    if(server>0 && masterstat==1) sendcddb(dev);
    return 0;

  endcddb:;
    close(sock);
  }
  return -1;
}

/*
  This function builds and sends an email to freedb.org, if they don't have a cddb entry that i can get
  from other server
*/
int sendcddb(struct DEVICES *dev)
{
  char myctime[64];
  char maildata[64000];
  time_t t;
  int i;
  FILE *fp;
  char cmd[1024];

  t=time(NULL);
  strcpy(myctime,(char *)ctime(&t));
  myctime[strlen(myctime)-1]=0;
  sprintf(maildata,"Subject: cddb %s %08lx\n\n",dev->category,dev->serial);
  sprintf((char *)&maildata[strlen(maildata)],"# xmcd CD database file\n"
         "# Generated: %s by KAMount\n"
         "# \n"
         "# Track frame offsets:\n",myctime);

  for(i=0;i<dev->ntracks;i++)
    sprintf((char *)&maildata[strlen(maildata)],"#       %lu\n",dev->cddbtoc[i]->absframe);

  sprintf((char *)&maildata[strlen(maildata)],"# \n"
         "# Disc length: %u seconds\n"
         "# \n"
         "# Submitted via: KAMount %s\n"
         "# \n"
         "DISCID=%08lx\n"
         "DTITLE=%s\n",dev->nsecs,VERSION,dev->serial,dev->pname);

  for(i=0;i<dev->ntracks;i++)
    sprintf((char *)&maildata[strlen(maildata)],"TTITLE%u=%s\n",i,dev->cddbtoc[i]->pname);

  sprintf((char *)&maildata[strlen(maildata)],"EXTD=\n");

  for(i=0;i<dev->ntracks;i++)
    sprintf((char *)&maildata[strlen(maildata)],"EXTT%u=\n",i);

  sprintf((char *)&maildata[strlen(maildata)],"PLAYORDER=\n");

  sprintf(cmd,"sendmail freedb-submit@freedb.org");
//  sprintf(cmd,"sendmail medisoft@alohabbs.org.mx");
  if((fp=popen(cmd,"w"))!=NULL) {
    fprintf(fp,"%s\n",maildata);
    pclose(fp);
    printf("CDDB Entry submited\n");
  }
}
/*
  oook!!  here i check for premounted devices that i will handle, if some of they are already mounted then i
  fills the device structure, for not try to remount they.
*/
int checkpremounted(struct DEVICES *dev)
{
	FILE *fp;
	char buf[4096];
	char device[4096],path[4096],dev_type[4096];
	int i;
	
	if((fp=fopen("/etc/mtab","rt"))==NULL) return -1;
	while(fgets(buf,sizeof(buf),fp)) {
		sscanf(buf,"%s%s%s",device,path,dev_type);
		if(!strncmp(device,dev->device,strlen(dev->device))) {
  		for(i=0;fstype[i]!=NULL;i++) {
  			if(!strcmp(dev_type,fstype[i])) break;
  		}
  		strcpy(dev->pdevice,device);
			printf("%s premounted with %s %d\n",dev->pdevice,dev_type,i);
			if(fstype[i]!=NULL) {
				dev->fstype=i;
				dev->dev_type=4;
				return 0;
			}
		}
	}
	fclose(fp);
	return -1;
}
/*
  At this point of the documentation i feel very tired of writing dummy comments hehehe i guess they will serve somepeople
  with improving this simple but useful program
*/
int main(int argc, char **argv)
{
	int i;
	if(argc>1)
	  if(!strcmp(argv[1],"-d")) debug=1;
	printf("KAMount v%s for KDE. Mario Medina Software, 1988-2000\n",VERSION);
	dev=readConfig();	
	if(dev==NULL) {
		printf("Error: i can't open the configuration file /etc/automount.conf\n");
		exit(-1);
	}
	createdirs();
	signal(SIGTERM,(void *)sigterm);
	signal(SIGINT,(void *)sigterm);
	signal(SIGQUIT,(void *)sigterm);
	signal(SIGILL,(void *)sigterm);
	signal(SIGABRT,(void *)sigterm);
	signal(SIGKILL,(void *)sigterm);
	signal(SIGPIPE,(void *)sigterm);
	signal(SIGSTOP,(void *)sigterm);
	signal(SIGTSTP,(void *)sigterm);
	if(!debug) {
	  int i,s;
	  i=fork();
	  if(i) {
	    waitpid(i,&s,0);
	    exit(0);
	  } else {
	    if(fork()) exit(0);
	  }
	}
	while(1) {
		if(debug) printf("Scanning for inserted devices\n");
		for(i=0;dev[i]!=NULL;i++) {
		  if(dev[i]->mountcount==0) {
		    dev[i]->status=polldevice(dev[i]);
  			if(debug) printf("%s = %d\n",dev[i]->device,dev[i]->status);
  		}
			if((dev[i]->status&MEDIA)==MEDIA) {
			  if(dev[i]->mountcount==0) mountdevice(dev[i]);
    	} else if(dev[i]->mountcount==0) dev[i]->mountcount=0;
  		if(dev[i]->mountcount>0) dev[i]->mountcount--;
		}
		if(debug) printf("Scanning for unmounted devices\n");
		for(i=0;dev[i]!=NULL;i++) {
		  if((dev[i]->status&MEDIA)==MEDIA) {
  		  dev[i]->status|=pollumounted(dev[i]);
	  		if(debug) printf("%s = %d\n",dev[i]->device,dev[i]->status);
	  	}
  		if((dev[i]->status&EJECTED)==EJECTED) if(!umountdevice(dev[i])) dev[i]->mountcount=0;
		}
		sleep(2);
	}
}


/*
  well, it has been done, some final comments
  - may the force be with you
  - this program is in beta status, someday it will mount the devices rw but at this time only ro
  - i'm not responsible for nothing bad, but if you win the lotery, or a beautiful girl gives you a kiss, then
    is all my fault ;)
  - i make this program for making windoze/macintosh people, they need help with the complex task of mount and unmount
    a drive on linux, and for all linux users that want to make it nicer to use.
  - I spend a lot of time configuring, compiling, patching and some other tasks, but sometimes i want to USE linux, so
    this program makes it nicer :)
  - Linux Rulez...
  - From Nostradamus: if Micro$oft doesn't changes their stupid and closed way of think, they will "crash" with an
    0x0D or 0x0E protection fault in the module krnl32.dll hehehehehehehehe!
    Presonally i like MS Office, MS Publisher and sometimes IE, i don't know why they don't open the market and makes that
    programs for linux at an lower price i guess a lot of people will buy the software. on my country (Mexico) an update for
    office95 to office97 is about 300 USD, the total house income (ingreso percapita in spanish) in my country is about
    2000 USD... you know, spend one month of work on a software is a price to high to pay, then a lot, i say
    a LOT of people makes illegal copies of it. Fortunatly i use Staroffice on my house and on my work, then
    i don't have to pay anything, but 64mb of ram to run it.
  - Finally, in my favourite TV program, Star Trek, the main idea is that all the people works for their improvement and
    the improvement of the society, it sounds like OpenSource project... i still belive on the human race, we can do
    the things better, we can be nice with the others, we don't need to be agressive, but competitive, like the athletes.
    We must distroy the Money for being a better civilization; think about it. It is your homework...
*/